<%@ Page Language="C#" AutoEventWireup="true" Culture="auto" meta:resourcekey="page" UICulture="auto" %>
<%@ Register Assembly="System.Web.Extensions, Version=1.0.61025.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35" Namespace="System.Web.UI" TagPrefix="asp" %>
<%@ Import Namespace="LogicBase.Core.Models.Workflow" %>
<%@ Import Namespace="LogicBase.Core" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<script runat="server">

  private string GetString(string key) {
	return (string)GetLocalResourceObject(key);
  }
  
  delegate string GetStringFunc(string key);
  
  class AssignmentItem {
	private readonly TaskAssignmentStructure.TaskAssignment data;
	private readonly GetStringFunc getString;
	public AssignmentItem(TaskAssignmentStructure.TaskAssignment data, GetStringFunc getString) {
		this.data = data;
		this.getString = getString;
	}
	public string AssignmentType {
		get {
			return getString("assignmentType." + data.AssignmentType.ToString());
		}
	}
	public string AssignTo {
		get {
			return data.AssignTo;
		}
	}
	public TaskAssignmentType Type {
		get {
			return data.AssignmentType;
		}
	}
  }
  
  class AssignmentTypeItem {
	private readonly string name;
	private readonly TaskAssignmentType value;
	public AssignmentTypeItem(string name, TaskAssignmentType value) {
		this.name = name;
		this.value = value;
	}
	public string Name {
		get {
			return name;
		}
	}
	public TaskAssignmentType Value {
		get {
			return value;
		}
	}
  }

  class TaskItem {
	private readonly TaskAssignmentStructure data;
	private readonly GetStringFunc getString;
	public TaskItem(TaskAssignmentStructure data, GetStringFunc getString) {
		this.data = data;
		this.getString = getString;
	}
	public string TaskID {
		get {
			return data.TaskID;
		}
	}
	public string TaskTypeID {
		get {
			if (data.TaskTypeID == "Form")
				return getString("code.Form");
			else				
				return data.TaskTypeID;
		}
	}
	public string TaskName {
		get {
			return data.TaskName;
		}
	}
	public string ComponentName {
		get {
			return data.ComponentName;
		}
	}
	public string CreatedBy {
		get {
			return data.CreatedBy;
		}
	}
  }

  class TaskResponseItem {
	private readonly TaskAssignmentStructure.TaskResponse data;
	private readonly GetStringFunc getString;
	public TaskResponseItem(TaskAssignmentStructure.TaskResponse data, GetStringFunc getString) {
		this.data = data;
		this.getString = getString;
	}
	public string Type {
		get {
			switch (data.Type) {
			case "UrlOfProcess": return getString("code.UrlOfProcess");
			case "UrlOfResponseService": return getString("code.UrlOfResponseService");
			case "PageURL": return getString("code.PageURL");
			default: return data.Type;
			}
		}
	}
	public string URL {
		get {
			return data.URL;
		}
	}
  }
  
  class TriggerItem {
	private readonly WorkQueueTrigger data;	
	private readonly GetStringFunc getString;
	public TriggerItem(WorkQueueTrigger data, GetStringFunc getString) {
		this.data = data;
		this.getString = getString;
	}
	public int Sequence {
		get {
			return data.Sequence;
		}
	}
	public string TriggerType {
		get {
			switch (data.TriggerType) {
			case WorkQueueTriggerType.TIMEOUT: return getString("code.Timeout");
			case WorkQueueTriggerType.ESCALATION: return getString("code.Escalation");
			default: return data.TriggerType.ToString();
			}
		}
	}	
	public DateTime TriggerTime {
		get {
			return data.TriggerTime;
		}
	}
	public string Processed {
		get {
			if (data.Processed)
				return getString("code.Yes");
			else
				return getString("code.No");
		}
	}
  }
  
  protected void Page_Load(object sender, EventArgs e)
  {
    try
    {
      if (!IsPostBack)
      {
        if (Request["InactiveWorkflowType"] != null)
        {
          LoadInactiveWorkflowDetails();
          updtPnlStats.Visible = false;
          pnlTaskList.Visible = false;
          updPnlTaskDetails.Visible = false;
          pnlCurrentProcesses.Visible = false;
          pnlExecutionHistory.Visible = false;
          pnlInactiveWorkflow.Visible = true;
        }
        else if (Request["TaskID"] != null)
        {
          LoadTaskDetails();
          updtPnlStats.Visible = false;
          pnlTaskList.Visible = false;
          updPnlTaskDetails.Visible = true;
          pnlCurrentProcesses.Visible = false;
          pnlExecutionHistory.Visible = false;
          pnlInactiveWorkflow.Visible = false;
        }
        else if (Request["HistoryTrackingID"] != null)
        {
          updtPnlStats.Visible = false;
          pnlTaskList.Visible = false;
          updPnlTaskDetails.Visible = false;
          pnlCurrentProcesses.Visible = false;
          pnlExecutionHistory.Visible = true;
          pnlInactiveWorkflow.Visible = false;

          WorkStatus statusHistoryItems = WorkflowServices.TrackStatus(Request["HistoryTrackingID"]);
          if (statusHistoryItems.StatusItems != null && statusHistoryItems.StatusItems.Length > 0)
          {
            gvExecutionHistory.DataSource = statusHistoryItems.StatusItems;
            gvExecutionHistory.DataBind();
          }
          lblHistoryTrackingID.Text = Request["HistoryTrackingID"];
        }
        else
        {
          if (Request["AbortTrackingID"] != null)
          {
            AbortWorkflow();
          }
          pnlInactiveWorkflow.Visible = false;
          updtPnlStats.Visible = false;
          pnlTaskList.Visible = true;
          updPnlTaskDetails.Visible = false;
          pnlCurrentProcesses.Visible = false;
          pnlExecutionHistory.Visible = false;
          if (Request["TrackingID"] != null)
          {
            LoadTrackingIDTasks();
          }
          else if (Request["taskAssignmentType"] != null)
          {
            if (Request["taskAssignmentType"] == "Unassigned")
            {
              LoadUnassignedTasks();
            }
            else if (Request["taskAssignmentType"] == "CurrentProcesses")
            {
              LoadAllTasks();
              updtPnlStats.Visible = false;
              pnlTaskList.Visible = false;
              updPnlTaskDetails.Visible = false;
              pnlCurrentProcesses.Visible = true;
            }
            else
            {
              TaskAssignmentType taskAssignmentType = (TaskAssignmentType)Enum.Parse(
                typeof(TaskAssignmentType), Request["taskAssignmentType"]);
              string name = Request["name"];

              LoadTasks(name, taskAssignmentType);
            }
          }
          else
          {
            LoadStats();
            pnlTaskList.Visible = false;
            updPnlTaskDetails.Visible = false;
            pnlCurrentProcesses.Visible = false;
            updtPnlStats.Visible = true;
          }
        }
      }
      lblErrorMessage.Text = "";
    }
    catch (Exception ex)
    {
      lblErrorMessage.Text = GetString("code.Error") + ex.ToString();
    }
  }

  private void AbortWorkflow()
  {
    try
    {
      WorkflowServices.AbortWorkflowProcess(Request["AbortTrackingID"]);
    }
    catch
    {
    }
  }

  private void LoadInactiveWorkflowDetails()
  {
    InactiveWorkflowType inactiveWorkflowType = (InactiveWorkflowType)
      Enum.Parse(typeof(InactiveWorkflowType), Request["InactiveWorkflowType"]);

    InactiveWorkflowHeader[] headers = WorkflowServices.GetInactiveWorkflowWorkflows(inactiveWorkflowType, false);

    lblInactiveWorkflowType.Text = Request["InactiveWorkflowType"];

    gvInactiveWorkflow.DataSource = headers;
    gvInactiveWorkflow.DataBind();
  }
  
  private void BindTaskList(TaskAssignmentStructure[] tasks) {
    ArrayList taskItems = new ArrayList();
    
    if (tasks != null) {
		foreach (TaskAssignmentStructure task in tasks) {
			taskItems.Add(new TaskItem(task, new GetStringFunc(GetString)));
		}
    }
    
    gvTaskList.DataSource = taskItems;
    gvTaskList.DataBind();
  }
  
  private void LoadTrackingIDTasks()
  {
    BindTaskList(WorkflowServices.GetTasksForProcess(Request["TrackingID"]));

    lblTaskListName.Text = String.Format(GetString("code.TaskListName"),
      GetString("code.TrackingID"), Request["TrackingID"]);

    hlBackToCurrentProcesses.Visible = true;
  }

  private void LoadAllTasks()
  {
    WorkflowProcess[] processes = WorkflowServices.GetCurrentProcesses();
    gvCurrentProcesses.DataSource = processes;
    gvCurrentProcesses.DataBind();
  }

  private void LoadTaskDetails()
  {
    string taskId = Request["TaskID"];
    string trackingId = Request["TrackingID"];

    if (String.IsNullOrEmpty(taskId))
      return;

    TaskAssignmentStructure taskAssignmentStructure = WorkflowServices.GetTaskAssignment(taskId);
    lblTaskName.Text = taskAssignmentStructure.TaskName;
    lblTaskDescription.Text = taskAssignmentStructure.Description;
    lblComponentName.Text = taskAssignmentStructure.ComponentName;
    if (taskAssignmentStructure.TaskTypeID == "Form")
		lblTaskType.Text = GetString("code.Form");
	else
		lblTaskType.Text = taskAssignmentStructure.TaskTypeID;
    lblTaskID.Text = taskAssignmentStructure.TaskID;
    lblProject.Text = taskAssignmentStructure.CreatedBy;
    lblTaskPriority.Text = GetString("taskPriority." + taskAssignmentStructure.TaskPriority.ToString());
    lblModelName.Text = taskAssignmentStructure.ModelName;
    lblTrackingID.Text = taskAssignmentStructure.TrackingID;
    hlViewTrackingTasks.NavigateUrl = "?TrackingID=" + trackingId;

    if (taskAssignmentStructure.DueDate != null)
      lblDueDate.Text = taskAssignmentStructure.DueDate.ToString();

    if (taskAssignmentStructure.LateDate != null)
      lblLateDate.Text = taskAssignmentStructure.LateDate.ToString();
      
    ArrayList responseItems = new ArrayList();
      
    if (taskAssignmentStructure.Responses != null) {
		foreach (TaskAssignmentStructure.TaskResponse response in taskAssignmentStructure.Responses) {
			responseItems.Add(new TaskResponseItem(response, new GetStringFunc(GetString)));
	    }
    }

    gvResponses.DataSource = responseItems;
    gvResponses.DataBind();
    
    ArrayList assignmentItems = new ArrayList();
    
    if (taskAssignmentStructure.Assignments != null) {
		foreach (TaskAssignmentStructure.TaskAssignment assignment in taskAssignmentStructure.Assignments) {
			assignmentItems.Add(new AssignmentItem(assignment, new GetStringFunc(GetString)));
		}
	}

    gvAssignments.DataSource = assignmentItems;
    gvAssignments.DataBind();
    
    ArrayList assignmentTypeItems = new ArrayList();
    
    foreach (TaskAssignmentType assignmentType in Enum.GetValues(typeof(TaskAssignmentType))) {
		assignmentTypeItems.Add(new AssignmentTypeItem(GetString("assignmentType." + assignmentType.ToString()), assignmentType));
    }

    ddlAssignmentType.DataSource = assignmentTypeItems;
    ddlAssignmentType.DataBind();

    if (trackingId != null)
      hlBackToList.NavigateUrl = "?TrackingID=" + trackingId;
    else
      hlBackToList.NavigateUrl = "?taskAssignmentType=" + Request["TaskAssignmentType"] + "&Name=" + Request["Name"];
      
	ArrayList triggerItems = new ArrayList();
	WorkQueueTrigger[] triggers = WorkflowServices.GetTriggersForWorkflowItem(Request["TaskID"]);
	  
	if (triggers != null) {
		foreach (WorkQueueTrigger trigger in triggers) {
			triggerItems.Add(new TriggerItem(trigger, new GetStringFunc(GetString)));
		}
	}

	gvTriggers.DataSource = triggerItems;
	gvTriggers.DataBind();
  }
  
  private void LoadTasks(string name, TaskAssignmentType taskAssignmentType)
  {
    BindTaskList(WorkflowServices.GetTasks(name, taskAssignmentType));

    switch (taskAssignmentType)
    {
      case TaskAssignmentType.User:
        lblTaskListName.Text = String.Format(GetString("code.TasksAssignedToUser"), name);
        break;
      case TaskAssignmentType.Group:
        lblTaskListName.Text = String.Format(GetString("code.TasksAssignedToGroup"), name);
        break;
      case TaskAssignmentType.Permission:
        lblTaskListName.Text = String.Format(GetString("code.TasksAssignedToPermission"), name);
        break;
      case TaskAssignmentType.OrgUnit:
        lblTaskListName.Text = String.Format(GetString("code.TasksAssignedToOrganization"), name);
        break;
      case TaskAssignmentType.Queue:
        lblTaskListName.Text = String.Format(GetString("code.TasksAssignedToQueue"), name);
        break;
    }
  }

  private void LoadUnassignedTasks()
  {
    BindTaskList(WorkflowServices.GetUnassignedTasks());
    lblTaskListName.Text = GetString("code.UnassignedTasks");
  }

  private void LoadStats()
  {
    // Load the Counts
    hlCurrentProcessCount.Text = WorkflowServices.GetWorkflowProcessCount().ToString();
    hlUnassignedTasksCount.Text = WorkflowServices.GetUnassignedTasksCount().ToString();
    // Hyperlink the Counts

    Assignment[] userAssignments = WorkflowServices.GetAssignments(TaskAssignmentType.User);
    gvUserAssignments.DataSource = userAssignments;
    gvUserAssignments.DataBind();

    Assignment[] groupAssignments = WorkflowServices.GetAssignments(TaskAssignmentType.Group);
    gvGroupAssignments.DataSource = groupAssignments;
    gvGroupAssignments.DataBind();

    Assignment[] permissionAssignments = WorkflowServices.GetAssignments(TaskAssignmentType.Permission);
    gvPermissionAssignments.DataSource = permissionAssignments;
    gvPermissionAssignments.DataBind();

    Assignment[] orgAssignments = WorkflowServices.GetAssignments(TaskAssignmentType.OrgUnit);
    gvOrganizationAssignments.DataSource = orgAssignments;
    gvOrganizationAssignments.DataBind();

    Assignment[] queueAssignments = WorkflowServices.GetAssignments(TaskAssignmentType.Queue);
    gvQueueAssignments.DataSource = queueAssignments;
    gvQueueAssignments.DataBind();

    if (chkErrorCount.Checked)
    {
      hlErrorCount.Text = WorkflowServices.GetInactiveWorkflowCount(InactiveWorkflowType.Exception).ToString();
      hlErrorCount.NavigateUrl = "?InactiveWorkflowType=" + InactiveWorkflowType.Exception.ToString();
    }
    else
    {
      hlErrorCount.Text = GetString("code.CheckToGetCount");
    }

    if (chkCheckPointCount.Checked)
    {
      hlCheckPointCount.Text = WorkflowServices.GetInactiveWorkflowCount(InactiveWorkflowType.Checkpoint).ToString();
      hlCheckPointCount.NavigateUrl = "?InactiveWorkflowType=" + InactiveWorkflowType.Checkpoint.ToString();
    }
    else
    {
      hlCheckPointCount.Text = GetString("code.CheckToGetCount");
    }

    if (chkArchiveCount.Checked)
    {
      hlArchiveCount.Text = WorkflowServices.GetInactiveWorkflowCount(InactiveWorkflowType.Archive).ToString();
      hlArchiveCount.NavigateUrl = "?InactiveWorkflowType=" + InactiveWorkflowType.Archive.ToString();
    }
    else
    {
      hlArchiveCount.Text = GetString("code.CheckToGetCount");
    }
  }

  protected void gvTaskList_RowDataBound(object sender, GridViewRowEventArgs e)
  {
    if (e.Row.RowType == DataControlRowType.DataRow)
    {
      HyperLink hlView = (HyperLink)e.Row.FindControl("hlViewLink");
      if (Request["TrackingID"] != null)
      {
        hlView.NavigateUrl += "&TrackingID=" + Request["TrackingID"];
      }
      else
      {
        hlView.NavigateUrl += "&Name=" + Request["Name"] + "&TaskAssignmentType=" + Request["TaskAssignmentType"];
      }
    }
  }

  protected void gvAssignments_RowDeleting(object sender, GridViewDeleteEventArgs e)
  {
    string taskId = Request["TaskID"];
    DataKey key = gvAssignments.DataKeys[e.RowIndex];
    TaskAssignmentType type = (TaskAssignmentType)key[0];
    string name = (string)key[1];
    WorkflowServices.RemoveAssignment(taskId, name, type);
    LoadTaskDetails();
  }

  protected void gvAssignments_RowDataBound(object sender, GridViewRowEventArgs e)
  {
    if (e.Row.RowType == DataControlRowType.DataRow)
    {
      ((LinkButton)e.Row.Cells[2].Controls[0]).Attributes["onclick"] =
        String.Format("javascript:return confirm('{0}')", GetString("code.ConfirmRemoveAssignment"));
    }
  }

  protected void btnAdd_Click(object sender, EventArgs e)
  {
    if (!String.IsNullOrEmpty(txtName.Text))
    {
      string taskID = Request["TaskID"];
      WorkflowServices.AddAssignment(taskID, txtName.Text, (TaskAssignmentType)Enum.Parse(typeof(TaskAssignmentType), ddlAssignmentType.SelectedValue));
      LoadTaskDetails();
      ddlAssignmentType.SelectedIndex = -1;
      txtName.Text = "";
    }
  }

  protected void gvCurrentProcesses_RowDataBound(object sender, GridViewRowEventArgs e)
  {
    if (e.Row.RowType == DataControlRowType.DataRow)
    {
      string trackingID = e.Row.Cells[1].Text;
      e.Row.Cells[2].Text = WorkflowServices.GetTasksForProcess(trackingID).Length.ToString();
    }
  }

  protected void refreshTimer_Tick(object sender, EventArgs e)
  {
    if (!chkStopPolling.Checked)
    {
      if (pnlProcessAndAssignment.Visible)
      {
        if (Request["TaskID"] == null && Request["TrackingID"] == null && Request["taskAssignmentType"] == null)
        {
          try
          {
            LoadStats();
            lblErrorMessage.Text = "";
          }
          catch (Exception ex)
          {
            lblErrorMessage.Text = GetString("code.Error") + ex.ToString();
          }
        }
      }
    }
  }

  protected void gvExecutionHistory_RowDataBound(object sender, GridViewRowEventArgs e)
  {
    if (e.Row.RowType == DataControlRowType.DataRow)
    {
      WorkStatusItem statusItem = (WorkStatusItem)e.Row.DataItem;
      e.Row.Cells[0].Text = statusItem.When.ToString();
      e.Row.Cells[1].Text = statusItem.ComponentName;
      e.Row.Cells[2].Text = statusItem.EventType;
      e.Row.Cells[3].Text = statusItem.FinishPath;
      e.Row.Cells[4].Text = statusItem.Description;
    }
  }

  protected void btnRefresh_Click(object sender, EventArgs e)
  {
    try
    {
      LoadStats();
      lblErrorMessage.Text = "";
    }
    catch (Exception ex)
    {
      lblErrorMessage.Text = GetString("code.Error") + ex.ToString();
    }
  }

  protected void gvTriggers_RowDeleting(object sender, GridViewDeleteEventArgs e)
  {
    try {
		WorkflowServices.RemoveTrigger(Request["TaskID"], e.RowIndex);
	} 
	catch (Exception ex) {
      lblErrorMessage.Text = GetString("code.Error") + ex.ToString();
	}
    LoadTaskDetails();
  }

  protected void btnRemoveAllTriggers_Click(object sender, EventArgs e)
  {
    WorkflowServices.RemoveAllTriggers(Request["TaskID"]);
    LoadTaskDetails();
  }

  protected void btnPostpone_Click(object sender, EventArgs e)
  {
    if (!String.IsNullOrEmpty(txtTimeoutTime.Text))
    {
      WorkflowServices.PostponeTimeout(Request["TaskID"], DateTime.Parse(txtTimeoutTime.Text));
      LoadTaskDetails();
    }
  }

  protected void gvTriggers_RowCommand(object sender, GridViewCommandEventArgs e)
  {
    if (e.CommandName == "ChangeTiming")
    {
      if (!String.IsNullOrEmpty(txtNewTriggerTime.Text))
      {
        WorkflowServices.ChangeTriggerTiming(Request["TaskID"], int.Parse((string)e.CommandArgument), DateTime.Parse(txtNewTriggerTime.Text));
        LoadTaskDetails();
      }
    }
  }

  protected void gvInactiveWorkflow_RowDataBound(object sender, GridViewRowEventArgs e)
  {
    if (e.Row.RowType == DataControlRowType.DataRow)
    {
      InactiveWorkflowHeader header = (InactiveWorkflowHeader)e.Row.DataItem;
      e.Row.Cells[0].Text = header.ArchiveDateTime.ToString();
      e.Row.Cells[1].Text = header.Details;
      e.Row.Cells[2].Text = header.LastComponentName;
      e.Row.Cells[3].Text = header.LastModelName;
      e.Row.Cells[4].Text = header.IsRestartable.ToString();
    }
  }
</script>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <title>
    <asp:Localize Text="Workflow Management" meta:resourcekey="title" runat="server" />
  </title>
  <style type="text/css">
    body, input {
      font-family: Verdana;
      font-size: 10pt;
    }
    .titleTD {
      background-color: lightblue;
      font-weight: bold;
      padding: 3px;
    }
    .fieldTitleTD {
      font-weight: bold;
    }
    .assignmentTable {
      border:solid 1px black;
    }
  </style>
</head>
<body>
  <form id="form1" runat="server">
  <asp:ScriptManager ID="ScriptManager1" runat="server" />
  <asp:Timer ID="refreshTimer" runat="server" Interval="10000" OnTick="refreshTimer_Tick" />

  <div style="padding:3px;text-align:center">
    <h2><asp:Localize runat="server" meta:resourcekey="lblStatistics" Text="Workflow Management Statistics" /></h2>
  </div>

  <asp:UpdatePanel ID="updtPnlStats" runat="server">
    <ContentTemplate>
      <table cellpadding="3" style="width: 100%">
        <tr>
          <td>
            <asp:Panel runat="server" ID="pnlProcessAndAssignment">
              <div align="center" style="border-bottom:solid 1px black;padding:5px">
                <asp:Label ID="lblErrorMessage" runat="server" ForeColor="Red" />
              </div>
              <div align="right" style="border-bottom:solid 1px black;padding:5px;margin-bottom:3px">
                <asp:LinkButton runat="server" ID="btnRefresh" Text="Refresh" OnClick="btnRefresh_Click"
                  meta:resourcekey="btnRefresh" />
              </div>
              <table cellpadding="5" cellspacing="1" class="assignmentTable">
                <tr>
                  <td class="titleTD">
                    <asp:HyperLink ID="hlCurrentProcess" runat="server" Text="Current Processes:" meta:resourcekey="hlCurrentProcess" />
                  </td>
                  <td>
                    <asp:HyperLink ID="hlCurrentProcessCount" runat="server" />&nbsp;
                    <asp:HyperLink ID="hlViewCurrentProcesses" runat="server" Text="[View]" NavigateUrl="?taskAssignmentType=CurrentProcesses"
                      meta:resourcekey="hlViewCurrentProcesses" />
                  </td>
                </tr>
                <tr>
                  <td class="titleTD">
                    <asp:HyperLink ID="hlUnassignedTasks" runat="server" Text="Unassigned Tasks:" meta:resourcekey="hlUnassignedTasks" />
                  </td>
                  <td>
                    <asp:HyperLink ID="hlUnassignedTasksCount" runat="server" />&nbsp;
                    <asp:HyperLink ID="hlViewUnassignedTasks" runat="server" Text="[View]" NavigateUrl="?taskAssignmentType=Unassigned"
                      meta:resourcekey="hlViewUnassignedTasks" />
                  </td>
                </tr>
                <tr>
                  <td class="titleTD">
                    <asp:Localize runat="server" meta:resourcekey="lblErrorCount" Text="Error Count:" />
                  </td>
                  <td>
                    <asp:CheckBox ID="chkErrorCount" runat="server" />
                    <asp:HyperLink ID="hlErrorCount" runat="server" />
                  </td>
                </tr>
                <tr>
                  <td class="titleTD">
                    <asp:Localize runat="server" meta:resourcekey="lblCheckpointFailedCount" Text="Checkpoint Failed Count:" />
                  </td>
                  <td>
                    <asp:CheckBox ID="chkCheckPointCount" runat="server" />
                    <asp:HyperLink ID="hlCheckPointCount" runat="server" />
                  </td>
                </tr>
                <tr>
                  <td class="titleTD">
                    <asp:Localize runat="server" meta:resourcekey="lblArchiveCount" Text="Archive Count:" />
                  </td>
                  <td>
                    <asp:CheckBox ID="chkArchiveCount" runat="server" />
                    <asp:HyperLink ID="hlArchiveCount" runat="server" />
                  </td>
                </tr>
                <tr>
                  <td class="titleTD">
                    <asp:Localize runat="server" meta:resourcekey="lblStopPolling" Text="Stop Polling:" />
                  </td>
                  <td>
                    <asp:CheckBox ID="chkStopPolling" runat="server" />
                </tr>
              </table>
            </asp:Panel>
          </td>
        </tr>
        <tr>
          <td>
            <table cellpadding="0" cellspacing="0" width="100%" class="assignmentTable">
              <tr>
                <td align="center" class="titleTD">
                  <asp:Localize runat="server" meta:resourcekey="lblUserAssignments" Text="User Assignments" />
                </td>
              </tr>
              <tr>
                <td>
                  <asp:GridView ID="gvUserAssignments" runat="server" AutoGenerateColumns="False" CellPadding="4"
                    EmptyDataText="None" ForeColor="#333333" GridLines="None" Width="100%" EnableModelValidation="True"
                    meta:resourcekey="gvUserAssignments">
                    <AlternatingRowStyle BackColor="White" />
                    <Columns>
                      <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=User "
                        DataTextField="Name" HeaderText="Name" meta:resourcekey="gvcName">
                        <HeaderStyle Width="80%" HorizontalAlign="Left" />
                        <ItemStyle Width="80%" />
                      </asp:HyperLinkField>
                      <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=User "
                        DataTextField="Count" HeaderText="Count" meta:resourcekey="gvcCount">
                        <HeaderStyle HorizontalAlign="Center" Width="20%" />
                        <ItemStyle HorizontalAlign="Center" Width="20%" />
                      </asp:HyperLinkField>
                    </Columns>
                    <EditRowStyle BackColor="#2461BF" />
                    <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                  </asp:GridView>
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <td>
            <table cellpadding="0" cellspacing="0" width="100%" class="assignmentTable">
              <tr>
                <td align="center" class="titleTD">
                  <asp:Localize runat="server" meta:resourcekey="lblGroupAssignments" Text="Group Assignments" />
                </td>
              </tr>
              <tr>
                <td>
                  <asp:GridView ID="gvGroupAssignments" runat="server" AutoGenerateColumns="False"
                    CellPadding="4" EmptyDataText="None" ForeColor="#333333" GridLines="None" Width="100%"
                    EnableModelValidation="True" meta:resourcekey="gvGroupAssignments">
                    <AlternatingRowStyle BackColor="White" />
                    <Columns>
                      <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Group "
                        DataTextField="Name" HeaderText="Name" meta:resourcekey="gvcName">
                        <HeaderStyle HorizontalAlign="Left" Width="80%" />
                        <ItemStyle HorizontalAlign="Left" Width="80%" />
                      </asp:HyperLinkField>
                      <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Group "
                        DataTextField="Count" HeaderText="Count" meta:resourcekey="gvcCount">
                        <HeaderStyle HorizontalAlign="Center" Width="20%" />
                        <ItemStyle HorizontalAlign="Center" Width="20%" />
                      </asp:HyperLinkField>
                    </Columns>
                    <EditRowStyle BackColor="#2461BF" />
                    <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                  </asp:GridView>
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <td>
            <table cellpadding="0" cellspacing="0" width="100%" class="assignmentTable">
              <tr>
                <td align="center" class="titleTD">
                  <asp:Localize runat="server" meta:resourcekey="lblPermissionAssignments" Text="Permission Assignments" />
                </td>
              </tr>
              <tr>
                <td>
                  <asp:GridView ID="gvPermissionAssignments" runat="server" AutoGenerateColumns="False"
                    CellPadding="4" EmptyDataText="None" ForeColor="#333333" GridLines="None" Width="100%"
                    EnableModelValidation="True" meta:resourcekey="gvPermissionAssignments">
                    <AlternatingRowStyle BackColor="White" />
                    <Columns>
                      <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Permission"
                        DataTextField="Name" HeaderText="Name" meta:resourcekey="gvcName">
                        <HeaderStyle Width="80%" HorizontalAlign="Left" />
                        <ItemStyle Width="80%" />
                      </asp:HyperLinkField>
                      <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Permission"
                        DataTextField="Count" HeaderText="Count" meta:resourcekey="gvcCount">
                        <HeaderStyle Height="20%" HorizontalAlign="Center" />
                        <ItemStyle HorizontalAlign="Center" Width="20%" />
                      </asp:HyperLinkField>
                    </Columns>
                    <EditRowStyle BackColor="#2461BF" />
                    <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                  </asp:GridView>
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <td>
            <table cellpadding="0" cellspacing="0" width="100%" class="assignmentTable">
              <tr>
                <td align="center" class="titleTD">
                  <asp:Localize runat="server" meta:resourcekey="lblOrgAssignments" Text="Organization Assignments" />
                </td>
              </tr>
              <tr>
                <td>
                  <asp:GridView ID="gvOrganizationAssignments" runat="server" AutoGenerateColumns="False"
                    CellPadding="4" EmptyDataText="None" ForeColor="#333333" GridLines="None" Width="100%"
                    EnableModelValidation="True" meta:resourcekey="gvOrganizationAssignments">
                    <AlternatingRowStyle BackColor="White" />
                    <Columns>
                      <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=OrgUnit"
                        DataTextField="Name" HeaderText="Name" meta:resourcekey="gvcName">
                        <HeaderStyle HorizontalAlign="Left" Width="80%" />
                        <ItemStyle HorizontalAlign="Left" Width="80%" />
                      </asp:HyperLinkField>
                      <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=OrgUnit"
                        DataTextField="Count" HeaderText="Count" meta:resourcekey="gvcCount">
                        <HeaderStyle HorizontalAlign="Center" Width="20%" />
                        <ItemStyle HorizontalAlign="Center" Width="20%" />
                      </asp:HyperLinkField>
                    </Columns>
                    <EditRowStyle BackColor="#2461BF" />
                    <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                  </asp:GridView>
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <td>
            <table cellpadding="0" cellspacing="0" width="100%" class="assignmentTable">
              <tr>
                <td align="center" class="titleTD">
                  <asp:Localize runat="server" meta:resourcekey="lblQueueAssignments" Text="Queue Assignments" />
                </td>
              </tr>
              <tr>
                <td>
                  <asp:GridView ID="gvQueueAssignments" runat="server" AutoGenerateColumns="False"
                    CellPadding="4" EmptyDataText="None" ForeColor="#333333" GridLines="None" Width="100%"
                    EnableModelValidation="True" meta:resourcekey="gvQueueAssignments">
                    <AlternatingRowStyle BackColor="White" />
                    <Columns>
                      <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Queue"
                        DataTextField="Name" HeaderText="Name" meta:resourcekey="gvcName">
                        <HeaderStyle Width="80%" HorizontalAlign="Left" />
                        <ItemStyle Width="80%" />
                      </asp:HyperLinkField>
                      <asp:HyperLinkField DataNavigateUrlFields="Name" DataNavigateUrlFormatString="?name={0}&amp;taskAssignmentType=Queue"
                        DataTextField="Count" HeaderText="Count" meta:resourcekey="gvcCount">
                        <HeaderStyle HorizontalAlign="Center" Width="20%" />
                        <ItemStyle HorizontalAlign="Center" Width="20%" />
                      </asp:HyperLinkField>
                    </Columns>
                    <EditRowStyle BackColor="#2461BF" />
                    <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
                    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
                    <RowStyle BackColor="#EFF3FB" />
                    <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
                  </asp:GridView>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </ContentTemplate>
    <Triggers>
      <asp:AsyncPostBackTrigger ControlID="refreshTimer" EventName="Tick" />
    </Triggers>
  </asp:UpdatePanel>
  
  <asp:Panel ID="pnlTaskList" runat="server">
    <table cellpadding="3" style="width: 100%">
      <tr>
        <td align="center">
          <b>
            <asp:Label ID="lblTaskListName" runat="server" /></b>
        </td>
      </tr>
      <tr>
        <td>
          <asp:GridView ID="gvTaskList" runat="server" AutoGenerateColumns="False" CellPadding="4"
            ForeColor="#333333" GridLines="None" Width="100%"
            OnRowDataBound="gvTaskList_RowDataBound" EnableModelValidation="True">
            <AlternatingRowStyle BackColor="White" />
            <Columns>
              <asp:BoundField DataField="TaskName" HeaderText="Task Name" meta:resourcekey="gvcTaskName" />
              <asp:BoundField DataField="ComponentName" HeaderText="Component Name" meta:resourcekey="gvcComponentName" />
              <asp:BoundField DataField="TaskTypeID" HeaderText="Task Type" meta:resourcekey="gvcTaskType" />
              <asp:BoundField DataField="CreatedBy" HeaderText="Project" meta:resourcekey="gvcProject" />
              <asp:TemplateField HeaderText="View" meta:resourcekey="gvViewTask">
                <ItemTemplate>
                  <asp:HyperLink ID="hlViewLink" runat="server" meta:resourcekey="hlViewLink" NavigateUrl='<%# Eval("TaskID", "?TaskID={0}") %>'
                    Text="View"></asp:HyperLink>
                </ItemTemplate>
              </asp:TemplateField>
            </Columns>
            <EditRowStyle BackColor="#2461BF" />
            <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" HorizontalAlign="Left" />
            <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
            <RowStyle BackColor="#EFF3FB" />
            <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
          </asp:GridView>
        </td>
      </tr>
      <tr>
        <td>
          <asp:HyperLink ID="lbBackToStats" runat="server" Text="Back to Main Page" NavigateUrl="?"
            meta:resourcekey="hlBackToMainPage" />
          |
          <asp:HyperLink ID="hlBackToCurrentProcesses" Visible="False" runat="server" Text="Back to Current Processes"
            NavigateUrl="?TaskAssignmentType=CurrentProcesses" meta:resourcekey="hlBackToCurrentProcesses" />
        </td>
      </tr>
    </table>
  </asp:Panel>
  
  <asp:UpdatePanel ID="updPnlTaskDetails" runat="server">
    <ContentTemplate>
      <table cellpadding="4" cellspacing="1" style="width: 100%" bgcolor="#ffffff">
        <tr>
          <td width="20%" class="fieldTitleTD"><asp:Localize runat="server" meta:resourcekey="lblTaskName" Text="Task Name:" /></td>
          <td><asp:Label ID="lblTaskName" runat="server" /></td>
        </tr>
        <tr>
          <td class="fieldTitleTD"><asp:Localize runat="server" meta:resourcekey="lblTaskDescription" Text="Task Description:" /></td>
          <td><asp:Label ID="lblTaskDescription" runat="server" /></td>
        </tr>
        <tr>
          <td class="fieldTitleTD"><asp:Localize runat="server" meta:resourcekey="lblModelName" Text="Model Name:" /></td>
          <td><asp:Label ID="lblModelName" runat="server" /></td>
        </tr>
        <tr>
          <td class="fieldTitleTD"><asp:Localize runat="server" meta:resourcekey="lblComponentName" Text="Component Name:" /></td>
          <td><asp:Label ID="lblComponentName" runat="server" /></td>
        </tr>
        <tr>
          <td class="fieldTitleTD"><asp:Localize runat="server" meta:resourcekey="lblTaskPriority" Text="Task Priority:" /></td>
          <td><asp:Label ID="lblTaskPriority" runat="server" /></td>
        </tr>
        <tr>
          <td class="fieldTitleTD"><asp:Localize runat="server" meta:resourcekey="lblTaskType" Text="Task Type:" />
          </td>
          <td>
            <asp:Label ID="lblTaskType" runat="server" />
          </td>
        </tr>
        <tr>
          <td class="fieldTitleTD">
            <asp:Localize runat="server" meta:resourcekey="lblTrackingId" Text="Tracking ID:" />
          </td>
          <td>
            <asp:Label ID="lblTrackingID" runat="server" />
            <asp:HyperLink ID="hlViewTrackingTasks" Text="[View Current Tasks]" meta:resourcekey="hlViewTrackingTasks"
              runat="server" />
          </td>
        </tr>
        <tr>
          <td class="fieldTitleTD">
            <asp:Localize runat="server" meta:resourcekey="lblTaskId" Text="Task ID:" />
          </td>
          <td>
            <asp:Label ID="lblTaskID" runat="server" />
          </td>
        </tr>
        <tr>
          <td class="fieldTitleTD">
            <asp:Localize runat="server" meta:resourcekey="lblProject" Text="Project:" />
          </td>
          <td>
            <asp:Label ID="lblProject" runat="server" />
          </td>
        </tr>
        <tr>
          <td class="fieldTitleTD">
            <asp:Localize runat="server" meta:resourcekey="lblDueDate" Text="Due Date:" />
          </td>
          <td>
            <asp:Label ID="lblDueDate" runat="server" />
          </td>
        </tr>
        <tr>
          <td class="fieldTitleTD">
            <asp:Localize runat="server" meta:resourcekey="lblLateDate" Text="Late Date:" />
          </td>
          <td>
            <asp:Label ID="lblLateDate" runat="server" />
          </td>
        </tr>
        <tr>
          <td class="fieldTitleTD">
            <asp:Localize runat="server" meta:resourcekey="lblPostponeTimeout" Text="Postpone Timeout:" />
          </td>
          <td>
            <asp:TextBox ID="txtTimeoutTime" runat="server" />
            <asp:Button ID="btnPostpone" runat="server" OnClick="btnPostpone_Click" Text="Postpone"
              meta:resourcekey="btnPostpone" />
            <asp:CompareValidator ID="CompareValidator1" runat="server" ControlToValidate="txtTimeoutTime"
              ErrorMessage="Invalid Date" Operator="DataTypeCheck" Type="Date" meta:resourcekey="cvTimeout" />
          </td>
        </tr>
        <tr>
          <td class="fieldTitleTD" valign="top">
            <asp:Localize runat="server" meta:resourcekey="lblResponses" Text="Responses:" />
          </td>
          <td>
            <asp:GridView ID="gvResponses" runat="server" CellPadding="4" ForeColor="#333333"
              GridLines="None" AutoGenerateColumns="False" Width="100%" EnableModelValidation="True">
              <AlternatingRowStyle BackColor="White" />
              <Columns>
                <asp:BoundField DataField="Type" HeaderText="Type" meta:resourcekey="gvcType" />
                <asp:HyperLinkField DataNavigateUrlFields="URL" DataTextField="URL" HeaderText="URL"
                  Target="_blank" meta:resourcekey="gvcUrl" />
              </Columns>
              <EditRowStyle BackColor="#2461BF" />
              <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
              <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" HorizontalAlign="Left" />
              <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
              <RowStyle BackColor="#EFF3FB" />
              <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
            </asp:GridView>
          </td>
        </tr>
        <tr>
          <td class="fieldTitleTD" valign="top">
            <asp:Localize runat="server" meta:resourcekey="lblAssignments" Text="Assignments:" />
          </td>
          <td>
            <asp:GridView ID="gvAssignments" runat="server" CellPadding="4" ForeColor="#333333"
              GridLines="None" AutoGenerateColumns="False" OnRowDeleting="gvAssignments_RowDeleting"
              DataKeyNames="Type, AssignTo"
              Width="100%" OnRowDataBound="gvAssignments_RowDataBound" EnableModelValidation="True">
              <AlternatingRowStyle BackColor="White" />
              <Columns>
                <asp:BoundField DataField="AssignmentType" HeaderText="Type" meta:resourcekey="gvcAssignmentType" />
                <asp:BoundField DataField="AssignTo" HeaderText="Assigned To" meta:resourcekey="gvcAssignedTo" />
                <asp:CommandField ShowDeleteButton="True" DeleteText="Remove" meta:resourcekey="gvcAssignmentCommand" />
              </Columns>
              <EditRowStyle BackColor="#2461BF" />
              <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
              <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" HorizontalAlign="Left" />
              <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
              <RowStyle BackColor="#EFF3FB" />
              <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
            </asp:GridView>
          </td>
        </tr>
        <tr>
          <td>&nbsp;</td>
          <td>
            <table border="0" cellpadding="4" cellspacing="1">
              <tr>
                <td colspan="3" class="titleTD"><asp:Localize Text="Add Assignment" meta:resourcekey="lblAddAssignment" runat="server" /></td>
              </tr>
              <tr>
                <td class="fieldTitleTD"><asp:Localize runat="server" meta:resourcekey="lblAssignmentType" Text="Type:" /></td>
                <td colspan="2"><asp:DropDownList ID="ddlAssignmentType" DataTextField="Name" DataValueField="Value" runat="server" /></td>
              </tr>
              <tr>
                <td class="fieldTitleTD"><asp:Localize runat="server" meta:resourcekey="lblName" Text="Name:" /></td>
                <td><asp:TextBox ID="txtName" runat="server" /></td>
                <td><asp:Button ID="btnAdd" runat="server" Text="Add" OnClick="btnAdd_Click" meta:resourcekey="btnAdd" /></td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <td class="fieldTitleTD" valign="top">
            <asp:Localize runat="server" meta:resourcekey="lblTriggers" Text="Triggers:" />
          </td>
          <td>
            <asp:GridView ID="gvTriggers" runat="server" CellPadding="4" ForeColor="#333333"
              GridLines="None" AutoGenerateColumns="False" Width="100%" OnRowDeleting="gvTriggers_RowDeleting"
              OnRowCommand="gvTriggers_RowCommand" EnableModelValidation="True">
              <AlternatingRowStyle BackColor="White" />
              <Columns>
                <asp:BoundField DataField="Sequence" HeaderText="Sequence" meta:resourcekey="gvcSequence" />
                <asp:BoundField DataField="TriggerType" HeaderText="Type" meta:resourcekey="gvcTriggerType" />
                <asp:BoundField DataField="TriggerTime" HeaderText="Trigger Time" meta:resourcekey="gvcTriggerTime" />
                <asp:BoundField DataField="Processed" HeaderText="Processed" meta:resourcekey="gvcProcessed" />
                <asp:CommandField ShowDeleteButton="True" DeleteText="Remove" meta:resourcekey="gvcTriggerCommand" />
                <asp:ButtonField CommandName="ChangeTiming" Text="Change Timing" meta:resourcekey="gvcChangeTiming" />
              </Columns>
              <EditRowStyle BackColor="#2461BF" />
              <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
              <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" HorizontalAlign="Left" />
              <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
              <RowStyle BackColor="#EFF3FB" />
              <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
            </asp:GridView>
          </td>
        </tr>
        <tr>
          <td class="fieldTitleTD" valign="top">
          </td>
          <td>
            <asp:Localize runat="server" meta:resourcekey="lblNewTriggerTime" Text="New Trigger Time:" />
            <asp:TextBox ID="txtNewTriggerTime" runat="server" />
            <asp:CompareValidator ID="CompareValidator2" runat="server" ControlToValidate="txtNewTriggerTime"
              ErrorMessage="Invalid Date" Operator="DataTypeCheck" Type="Date" meta:resourcekey="cvTriggerTime" />
          </td>
        </tr>
        <tr>
          <td class="fieldTitleTD" valign="top">
          </td>
          <td align="right">
            <asp:LinkButton ID="btnRemoveAllTriggers" runat="server" OnClick="btnRemoveAllTriggers_Click"
              meta:resourcekey="btnRemoveAllTriggers" Text="Remove All Triggers" />
          </td>
        </tr>
        <tr>
          <td colspan="2">
            <asp:HyperLink runat="server" Text="Back to Main Page" NavigateUrl="?" meta:resourcekey="hlBackToMainPage" />
            | <asp:HyperLink ID="hlBackToList" runat="server" Text="Back to Task List" NavigateUrl="?"
              meta:resourcekey="hlBackToList" />
          </td>
        </tr>
      </table>
    </ContentTemplate>
  </asp:UpdatePanel>
  
  <asp:Panel ID="pnlCurrentProcesses" runat="server" meta:resourcekey="pnlCurrentProcesses">
    <table cellpadding="3" style="width: 100%">
      <tr>
        <td align="center">
          <b><asp:Localize runat="server" meta:resourcekey="lblCurrentProcesses" Text="Current Processes" /></b>
        </td>
      </tr>
      <tr>
        <td>
          <asp:GridView ID="gvCurrentProcesses" runat="server" AutoGenerateColumns="False"
            CellPadding="4" ForeColor="#333333" GridLines="None" OnRowDataBound="gvCurrentProcesses_RowDataBound"
            Width="100%" EnableModelValidation="True">
            <AlternatingRowStyle BackColor="White" />
            <Columns>
              <asp:BoundField DataField="StartedDateTime" HeaderText="Started" meta:resourcekey="gvcStartedDateTime">
                <ItemStyle Width="200px" />
              </asp:BoundField>
              <asp:BoundField DataField="TrackingID" HeaderText="Tracking ID" meta:resourcekey="gvcTrackingId" />
              <asp:TemplateField HeaderText="No of Tasks" meta:resourcekey="gvcNoOfTasks">
                <ItemTemplate>
                  <asp:Label ID="lblNoOfTasks" runat="server" />
                </ItemTemplate>
              </asp:TemplateField>
              <asp:HyperLinkField DataNavigateUrlFields="TrackingID" DataNavigateUrlFormatString="?TrackingID={0}"
                HeaderText="View Tasks" meta:resourcekey="gvcViewTasks" Text="View Tasks" />
              <asp:HyperLinkField DataNavigateUrlFields="TrackingID" DataNavigateUrlFormatString="?HistoryTrackingID={0}"
                HeaderText="View History" meta:resourcekey="gvcExecutionHistory" Text="Execution History" />
              <asp:HyperLinkField DataNavigateUrlFields="TrackingID" DataNavigateUrlFormatString="?AbortTrackingID={0}"
                HeaderText="Abort Workflow" meta:resourcekey="gvcAbort" Text="Abort" />
            </Columns>
            <EditRowStyle BackColor="#2461BF" />
            <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" HorizontalAlign="Left" />
            <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
            <RowStyle BackColor="#EFF3FB" />
            <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
          </asp:GridView>
        </td>
      </tr>
      <tr>
        <td>
          <asp:HyperLink runat="server" Text="Back to Main Page" NavigateUrl="?" meta:resourcekey="hlBackToMainPage" />
        </td>
      </tr>
    </table>
  </asp:Panel>

  <asp:Panel ID="pnlExecutionHistory" runat="server">
    <table cellpadding="3" style="width: 100%">
      <tr>
        <td align="center">
          <b>
            <asp:Localize runat="server" meta:resourcekey="lblExecutionHistory" Text="Execution History for Tracking ID:" />
            <asp:Label ID="lblHistoryTrackingID" runat="server" /></b>
        </td>
      </tr>
      <tr>
        <td>
          <asp:GridView ID="gvExecutionHistory" runat="server" AutoGenerateColumns="False"
            CellPadding="4" ForeColor="#333333" GridLines="None" Width="100%" OnRowDataBound="gvExecutionHistory_RowDataBound"
            EnableModelValidation="True">
            <AlternatingRowStyle BackColor="White" />
            <Columns>
              <asp:BoundField HeaderText="When" meta:resourcekey="gvcWhen">
                <ItemStyle Wrap="False" />
              </asp:BoundField>
              <asp:BoundField HeaderText="Component Name" meta:resourcekey="gvcComponentName" />
              <asp:BoundField HeaderText="Event Type" meta:resourcekey="gvcEventType" />
              <asp:BoundField HeaderText="Finished Path" meta:resourcekey="gvcFinishedPath" />
              <asp:BoundField HeaderText="Description" meta:resourcekey="gvcDescription" />
            </Columns>
            <EditRowStyle BackColor="#2461BF" />
            <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
            <RowStyle BackColor="#EFF3FB" />
            <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
          </asp:GridView>
        </td>
      </tr>
      <tr>
        <td>
          <asp:HyperLink runat="server" Text="Back to Main Page" NavigateUrl="?" meta:resourcekey="hlBackToMainPage" />
          |
          <asp:HyperLink runat="server" Text="Back to Current Processes" NavigateUrl="?TaskAssignmentType=CurrentProcesses"
            meta:resourcekey="hlBackToCurrentProcesses" />
        </td>
      </tr>
    </table>
  </asp:Panel>
  
  <asp:Panel ID="pnlInactiveWorkflow" runat="server">
    <table cellpadding="3" style="width: 100%">
      <tr>
        <td align="center">
          <b><asp:Localize runat="server" meta:resourcekey="lblInactiveWorkflowTasks" Text="Inactive Workflow Tasks of type:" />
            <asp:Label ID="lblInactiveWorkflowType" runat="server" /></b>
        </td>
      </tr>
      <tr>
        <td>
          <asp:GridView ID="gvInactiveWorkflow" runat="server" AutoGenerateColumns="False"
            CellPadding="4" ForeColor="#333333" GridLines="None" Width="100%" OnRowDataBound="gvInactiveWorkflow_RowDataBound"
            EnableModelValidation="True">
            <AlternatingRowStyle BackColor="White" />
            <Columns>
              <asp:BoundField HeaderText="Archive DateTime" meta:resourcekey="gvcArchiveDateTime" />
              <asp:BoundField HeaderText="Details" meta:resourcekey="gvcDetails" />
              <asp:BoundField HeaderText="Last Component Name" meta:resourcekey="gvcLastComponentName" />
              <asp:BoundField HeaderText="Last Model Name" meta:resourcekey="gvcLastModelName" />
              <asp:BoundField HeaderText="Is Restartable" meta:resourcekey="gvcIsRestartable" />
            </Columns>
            <EditRowStyle BackColor="#2461BF" />
            <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
            <RowStyle BackColor="#EFF3FB" />
            <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
          </asp:GridView>
        </td>
      </tr>
      <tr>
        <td>
          <asp:HyperLink runat="server" Text="Back to Main Page" NavigateUrl="?" meta:resourcekey="hlBackToMainPage" />
        </td>
      </tr>
    </table>
  </asp:Panel>
  
  </form>
</body>
</html>
